//+------------------------------------------------------------------+
//|                                                       myusdx.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_plots   1
//--- plot Label1
#property indicator_label1  "Label1"
#property indicator_type1   DRAW_COLOR_CANDLES
#property indicator_color1  clrRed,clrOliveDrab
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- input parameters
input int      Input1;
//--- indicator buffers
double         open_buf[];
double         high_buf[];
double         low_buf[];
double         close_buf[];
double         colors[];
//---
string para[]={"EURUSD","USDJPY","GBPUSD","USDCAD","USDSEK","USDCHF"};
double stepen[]={-0.576,0.136,-0.119,0.091,0.042,0.036};
double koef=50.14348112;
#include <Mylib\copy_series.mqh>
Ccopyseries rate;
MqlRates r_tmp[],r[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,open_buf,INDICATOR_DATA);
   SetIndexBuffer(1,high_buf,INDICATOR_DATA);
   SetIndexBuffer(2,low_buf,INDICATOR_DATA);
   SetIndexBuffer(3,close_buf,INDICATOR_DATA);
   SetIndexBuffer(4,colors,INDICATOR_COLOR_INDEX);
//---
   ArraySetAsSeries(open_buf,true);
   ArraySetAsSeries(low_buf,true);
   ArraySetAsSeries(high_buf,true);
   ArraySetAsSeries(close_buf,true);
   ArraySetAsSeries(colors,true);
//---

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate (const int rates_total,      //   
                 const int prev_calculated,  //     
                 const datetime& time[],     // Time
                 const double& open[],       // Open
                 const double& high[],       // High
                 const double& low[],        // Low
                 const double& close[],      // Close
                 const long& tick_volume[],  // Tick Volume
                 const long& volume[],       // Real Volume
                 const int& spread[]         // Spread
                 )
  {
   ArraySetAsSeries(time,true);
//---
   for(int i=0;i<rates_total-1;i++)
     {
      double cl=0,tmp[1];
      datetime time_eurusd[];
      ArraySetAsSeries(time_eurusd,true);
      if(CopyTime(para[0],PERIOD_H1,time[i],time[i+1],time_eurusd)==-1)break;
      double o=0,h=0,lo=DBL_MAX,c=0;
      //---
      for(int l=0;l<ArraySize(time_eurusd);l++)
        {
         for(int s=0;s<ArraySize(para);s++)
           {
            if(CopyClose(para[s],PERIOD_H1,time_eurusd[l],1,tmp)!=1)
               if(CopyClose(para[s],PERIOD_H1,time_eurusd[l],1,tmp)!=1)
                  if(CopyClose(para[s],PERIOD_H1,time_eurusd[l],1,tmp)!=1)
                     if(CopyClose(para[s],PERIOD_H1,time_eurusd[l],1,tmp)!=1)
                        if(CopyClose(para[s],PERIOD_H1,time_eurusd[l],1,tmp)!=1)
                           if(CopyClose(para[s],PERIOD_H1,time_eurusd[l],1,tmp)!=1)
                              if(CopyClose(para[s],PERIOD_H1,time_eurusd[l],1,tmp)!=1)
                                 if(CopyClose(para[s],PERIOD_H1,time_eurusd[l],1,tmp)!=1)
                                    if(CopyClose(para[s],PERIOD_H1,time_eurusd[l],1,tmp)!=1)
                                       if(CopyClose(para[s],PERIOD_H1,time_eurusd[l],1,tmp)!=1)
                                          if(CopyClose(para[s],PERIOD_H1,time_eurusd[l],1,tmp)!=1)
                                             return(0);
            if(s==0)
               cl=koef*MathPow(tmp[0],stepen[s]);
            else
               cl*=MathPow(tmp[0],stepen[s]);
           }
         if(l==0)o=cl;
         if(l==ArraySize(time_eurusd)-1)c=cl;
         if(h<cl)h=cl;
         if(lo>cl)lo=cl;
        }
      //---
      open_buf[i]=o;
      high_buf[i]=h;
      low_buf[i]=lo;
      close_buf[i]=c;
      if(o<c)colors[i]=0;else colors[i]=1;
     }

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
